]> CyberLeo.Net >> Repos - FreeBSD/FreeBSD.git/blob - tools/build/beinstall.sh
Add UPDATING entries and bump version.
[FreeBSD/FreeBSD.git] / tools / build / beinstall.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2016 Will Andrews
4 # All rights reserved.
5 #
6 # Redistribution and use in source and binary forms, with or without
7 # modification, are permitted provided that the following conditions
8 # are met:
9 # 1. Redistributions of source code must retain the above copyright
10 #    notice, this list of conditions and the following disclaimer 
11 #    in this position and unchanged.
12 # 2. Redistributions in binary form must reproduce the above copyright
13 #    notice, this list of conditions and the following disclaimer in the
14 #    documentation and/or other materials provided with the distribution.
15 #
16 # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
17 # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
18 # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
19 # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
20 # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
21 # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
22 # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
23 # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
24 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
25 # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
26 #
27 # $FreeBSD$
28 #
29 ##
30 # Install a boot environment using the current FreeBSD source tree.
31 # Requires a fully built world & kernel.
32 #
33 # Non-base tools required: beadm, pkg
34 #
35 # In a sandbox for the new boot environment, this script also runs etcupdate
36 # and pkg upgrade automatically in the sandbox.  Upon successful completion,
37 # the system will be ready to boot into the new boot environment.  Upon
38 # failure, the target boot environment will be destroyed.  In all cases, the
39 # running system is left untouched.
40 #
41 ## Usage:
42 # beinstall [optional world/kernel flags e.g. KERNCONF]
43 #
44 ## User modifiable variables - set these in the environment if desired.
45 # If not empty, 'pkg upgrade' will be skipped.
46 NO_PKG_UPGRADE="${NO_PKG_UPGRADE:-""}"
47 # Config updater - 'etcupdate' and 'mergemaster' are supported.  Set to an
48 # empty string to skip.
49 CONFIG_UPDATER="${CONFIG_UPDATER:-"etcupdate"}"
50 # Flags for etcupdate if used.
51 ETCUPDATE_FLAGS="${ETCUPDATE_FLAGS:-"-F"}"
52 # Flags for mergemaster if used.
53 MERGEMASTER_FLAGS="${MERGEMASTER_FLAGS:-"-iFU"}"
54
55
56 ########################################################################
57 ## Constants
58 ETCUPDATE_CMD="etcupdate"
59 MERGEMASTER_CMD="mergemaster"
60
61 ## Functions
62 cleanup() {
63         [ -z "${cleanup_commands}" ] && return
64         echo "Cleaning up ..."
65         for command in ${cleanup_commands}; do
66                 ${command}
67         done
68 }
69
70 errx() {
71         cleanup
72         echo "error: $@"
73         exit 1
74 }
75
76 rmdir_be() {
77         chflags -R noschg ${BE_MNTPT}
78         rm -rf ${BE_MNTPT}
79 }
80
81 unmount_be() {
82         mount | grep " on ${BE_MNTPT}" | awk '{print $3}' | sort -r | xargs -t umount -f
83 }
84
85 cleanup_be() {
86         # Before destroying, unmount any child filesystems that may have
87         # been mounted under the boot environment.  Sort them in reverse
88         # order so children are unmounted first.
89         unmount_be
90         # Finally, clean up any directories that were created by the
91         # operation, via cleanup_be_dirs().
92         if [ -n "${created_be_dirs}" ]; then
93                 chroot ${BE_MNTPT} /bin/rm -rf ${created_be_dirs}
94         fi
95         beadm destroy -F ${BENAME}
96 }
97
98 create_be_dirs() {
99         echo "${BE_MNTPT}: Inspecting dirs $*"
100         for dir in $*; do
101                 curdir="$dir"
102                 topdir="$dir"
103                 while :; do
104                         [ -e "${BE_MNTPT}${curdir}" ] && break
105                         topdir=$curdir
106                         curdir=$(dirname ${curdir})
107                 done
108                 [ "$curdir" = "$dir" ] && continue
109
110                 # Add the top-most nonexistent directory to the list, then
111                 # mkdir -p the innermost directory specified by the argument.
112                 # This way the least number of directories are rm'd directly.
113                 created_be_dirs="${topdir} ${created_be_dirs}"
114                 echo "${BE_MNTPT}: Created ${dir}"
115                 mkdir -p ${BE_MNTPT}${dir} || return $?
116         done
117         return 0
118 }
119
120 update_mergemaster_pre() {
121         mergemaster -p -m ${srcdir} -D ${BE_MNTPT} -t ${BE_MM_ROOT} ${MERGEMASTER_FLAGS}
122 }
123
124 update_mergemaster() {
125         chroot ${BE_MNTPT} \
126                 mergemaster -m ${srcdir} -t ${BE_MM_ROOT} ${MERGEMASTER_FLAGS}
127 }
128
129 update_etcupdate_pre() {
130         etcupdate -p -s ${srcdir} -D ${BE_MNTPT} ${ETCUPDATE_FLAGS} || return $?
131         etcupdate resolve -D ${BE_MNTPT} || return $?
132 }
133
134 update_etcupdate() {
135         chroot ${BE_MNTPT} \
136                 etcupdate -s ${srcdir} ${ETCUPDATE_FLAGS} || return $?
137         chroot ${BE_MNTPT} etcupdate resolve
138 }
139
140
141 # Special command-line subcommand that can be used to do a full cleanup
142 # after a manual post-mortem has been completed.
143 postmortem() {
144         [ -n "${BENAME}" ] || errx "Must specify BENAME"
145         [ -n "${BE_MNTPT}" ] || errx "Must specify BE_MNTPT"
146         echo "Performing post-mortem on BE ${BENAME} at ${BE_MNTPT} ..."
147         unmount_be
148         rmdir_be
149         echo "Post-mortem cleanup complete."
150         echo "To destroy the BE (recommended), run: beadm destroy ${BENAME}"
151         echo "To instead continue with the BE, run: beadm activate ${BENAME}"
152 }
153
154 if [ -n "$BEINSTALL_CMD" ]; then
155         ${BEINSTALL_CMD} $*
156         exit $?
157 fi
158
159
160 cleanup_commands=""
161 trap 'errx "Interrupt caught"' HUP INT TERM
162
163 [ "$(whoami)" != "root" ] && errx "Must be run as root"
164
165 [ ! -f "Makefile.inc1" ] && errx "Must be in FreeBSD source tree"
166 srcdir=$(pwd)
167 objdir=$(make -V .OBJDIR 2>/dev/null)
168 [ ! -d "${objdir}" ] && errx "Must have built FreeBSD from source tree"
169
170 # May be a worktree, in which case .git is a file, not a directory.
171 if [ -e .git ] ; then
172     commit_time=$(git show --format='%ct' 2>/dev/null | head -1)
173     [ $? -ne 0 ] && errx "Can't lookup git commit timestamp"
174     commit_ts=$(date -r ${commit_time} '+%Y%m%d.%H%M%S')
175 elif [ -d .svn ] ; then
176       if [ -e /usr/bin/svnlite ]; then
177         svn=/usr/bin/svnlite
178       elif [ -e /usr/local/bin/svn ]; then
179         svn=/usr/local/bin/svn
180       else
181         errx "Unable to find subversion"
182       fi
183       commit_ts="$( "$svn" info --show-item last-changed-date | sed -e 's/\..*//' -e 's/T/./' -e 's/-//g' -e s'/://g' )"
184     [ $? -ne 0 ] && errx "Can't lookup Subversion commit timestamp"
185 else
186     errx "Unable to determine source control type"
187 fi
188
189 commit_ver=$(${objdir}/bin/freebsd-version/freebsd-version -u 2>/dev/null)
190 [ -z "${commit_ver}" ] && errx "Unable to determine FreeBSD version"
191
192 BENAME="${commit_ver}-${commit_ts}"
193
194 BE_TMP=$(mktemp -d /tmp/beinstall.XXXXXX)
195 [ $? -ne 0 -o ! -d ${BE_TMP} ] && errx "Unable to create mountpoint"
196 [ -z "$NO_CLEANUP_BE" ] && cleanup_commands="rmdir_be ${cleanup_commands}"
197 BE_MNTPT=${BE_TMP}/mnt
198 BE_MM_ROOT=${BE_TMP}/mergemaster # mergemaster will create
199 mkdir -p ${BE_MNTPT}
200
201 beadm create ${BENAME} >/dev/null || errx "Unable to create BE ${BENAME}"
202 [ -z "$NO_CLEANUP_BE" ] && cleanup_commands="cleanup_be ${cleanup_commands}"
203
204 beadm mount ${BENAME} ${BE_TMP}/mnt || errx "Unable to mount BE ${BENAME}."
205
206 echo "Mounted ${BENAME} to ${BE_MNTPT}, performing install/update ..."
207 make "$@" DESTDIR=${BE_MNTPT} installkernel || errx "Installkernel failed!"
208 if [ -n "${CONFIG_UPDATER}" ]; then
209         "update_${CONFIG_UPDATER}_pre"
210         [ $? -ne 0 ] && errx "${CONFIG_UPDATER} (pre-world) failed!"
211 fi
212
213 # Mount the source and object tree within the BE in order to account for any
214 # changes applied by the pre-installworld updater.  Cleanup any directories
215 # created if they didn't exist previously.
216 create_be_dirs "${srcdir}" "${objdir}" || errx "Unable to create BE dirs"
217 mount -t nullfs "${srcdir}" "${BE_MNTPT}${srcdir}" || errx "Unable to mount src"
218 mount -t nullfs "${objdir}" "${BE_MNTPT}${objdir}" || errx "Unable to mount obj"
219 mount -t devfs devfs "${BE_MNTPT}/dev" || errx "Unable to mount devfs"
220
221 chroot ${BE_MNTPT} make "$@" -C ${srcdir} installworld || \
222         errx "Installworld failed!"
223
224 if [ -n "${CONFIG_UPDATER}" ]; then
225         "update_${CONFIG_UPDATER}"
226         [ $? -ne 0 ] && errx "${CONFIG_UPDATER} (post-world) failed!"
227 fi
228
229 BE_PKG="chroot ${BE_MNTPT} env ASSUME_ALWAYS_YES=true pkg"
230 if [ -z "${NO_PKG_UPGRADE}" ]; then
231         ${BE_PKG} update || errx "Unable to update pkg"
232         ${BE_PKG} upgrade || errx "Unable to upgrade pkgs"
233 fi
234
235 if [ -n "$NO_CLEANUP_BE" ]; then
236         echo "Boot Environment ${BENAME} may be examined in ${BE_MNTPT}."
237         echo "Afterwards, run this to cleanup:"
238         echo "  env BENAME=${BENAME} BE_MNTPT=${BE_MNTPT} BEINSTALL_CMD=postmortem $0"
239         exit 0
240 fi
241
242 unmount_be || errx "Unable to unmount BE"
243 rmdir_be || errx "Unable to cleanup BE"
244 beadm activate ${BENAME} || errx "Unable to activate BE"
245 echo
246 beadm list
247 echo
248 echo "Boot environment ${BENAME} setup complete; reboot to use it."